let result =
  let buf = Lexing.from_channel In_channel.stdin in
  let e = Myparser.prog Mylexer.read buf in
  Expr.eval e

let _ =
  print_int result; print_endline ""

let fullEval (str : (* well-formed *) string) : int =
  let buf = Lexing.from_string str in
  let e = Myparser.prog Mylexer.read buf in
  Expr.eval e