%token RPAREN
%token LPAREN
%token PLUS
%token MINUS
%token <int> INT
%token EOF

%start <Expr.expr> prog

%%

prog:
  | e = expr; EOF { e }
  ;

(* expr:
  | s = INT { Expr.Int s }
  | el = expr; PLUS; er = expr { Expr.Plus(el, er) }
  | el = expr; MINUS; er = expr {Expr.Minus(el, er) }
  | LPAREN; e = expr; RPAREN { e }
  ;

9 - 2 - 3
===> (9 - 2) - 3 <====== We like this.
   | 9 - (2 - 3)

9 - 1 - 1 - 1 - 1
===> ((9 - 1) - 1) - (1 - 1) <====== We dislike this interpretation.
===> (((9 - 1) - 1) - 1) - 1 *)

expr:
  | e = expr1 { e }
  ;

expr1:
  | e = expr0 { e }
  | el = expr1; PLUS; er = expr0 { Expr.Plus(el, er) }
  | el = expr1; MINUS; er = expr0 { Expr.Minus(el, er) }
  ;

expr0:
  | s = INT { Expr.Int s}
  | LPAREN; e = expr1; RPAREN { e }
  ;

(* expr:
  | s = INT { Expr.Int s }
  | el = expr; PLUS; sr = INT { Expr.Plus(el, Expr.Int sr) }
  | el = expr; PLUS; LPAREN; er = expr; RPAREN { Expr.Plus(el, er) }
  | el = expr; MINUS; sr = INT {Expr.Minus(el, Expr.Int sr) }
  | el = expr; MINUS; LPAREN; er = expr; RPAREN {Expr.Minus(el, er) }
  | LPAREN; e = expr; RPAREN { e }
  ; *)

(* 9 - (2) *)






